local WOKRAH_COMMS_EVENTS = CreateFrame("frame")
local ADDON_MESSAGE_PREFIX = 'WOKRAH'
local ADDON_MESSAGE_SUMMON = "SUMMON"
local ADDON_MESSAGE_SYNC = "SYNC"
WokrahComms = {}

local function Broadcast(msg)
    if Wokrah["IS_PLAYER_WARLOCK"] then
        local chatType = nil

        if IsInRaid() then
            chatType = "RAID"
        elseif IsInGroup() then
            chatType = "PARTY"
        end

        if chatType then
            C_ChatInfo.SendAddonMessage(ADDON_MESSAGE_PREFIX, msg, chatType)
        end
    end
end

local function CreateBroadcastMessage(subject, msg)
    local fullMsg = subject

    if msg then
        fullMsg = fullMsg.."\t"..msg
    end

    Broadcast(fullMsg)
end

-- /run Wokrah.Communication.SummonPlayerBroadcast("Wokrah")
function WokrahComms:SummonPlayerBroadcast(playerName)
    CreateBroadcastMessage(ADDON_MESSAGE_SUMMON, playerName)
end

function WokrahComms:SyncWithGroup(summonList)
    CreateBroadcastMessage(ADDON_MESSAGE_SYNC, summonList)
end

function WokrahComms:OnCommsReceived(...)
    local prefix, msg, channel, sender = ...

    -- Don't listen to our own broadcasts.
    local senderWithoutRealm = strsplit("-", sender)
    if senderWithoutRealm == UnitName("player") then
        return
    end

    if prefix == ADDON_MESSAGE_PREFIX then
        local msgType = strsplit("\t", msg)

        if msgType == ADDON_MESSAGE_SUMMON then
            local _, playerName = strsplit("\t", msg)
            WokrahReport:RemovePlayerFromList(playerName)
        end

        if msgType == ADDON_MESSAGE_SYNC then
            local _, summonList = strsplit("\t", msg)

            if summonList then
                WokrahReport:SetSummonList(summonList)
            else
                local list = WokrahReport:GetSummonListAsPlainText()
                WokrahComms:SyncWithGroup(list)
            end
        end
    end
end

function WokrahComms:OnLogin()
    local successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix(ADDON_MESSAGE_PREFIX)
    if not successfulRequest then
		print("WARNING: Something went wrong during initialization of the communication handler.")
	end
end