--[[
    CHAT EVENTS
]]
local chatEvents = CreateFrame("Frame")
local function ProcessMessage(event, ...)
    WokrahReport:ProcessMessage(event, ...)
end
chatEvents:RegisterEvent("CHAT_MSG_PARTY")
chatEvents:RegisterEvent("CHAT_MSG_PARTY_LEADER")
chatEvents:RegisterEvent("CHAT_MSG_RAID")
chatEvents:RegisterEvent("CHAT_MSG_RAID_LEADER")
chatEvents:RegisterEvent("CHAT_MSG_RAID_WARNING")
chatEvents:SetScript("OnEvent", function(self, event, ...) ProcessMessage(event, ...) end)

--[[
    GROUP EVENTS
]]
local groupEvents = CreateFrame("Frame")
local function RosterUpdate(...)
    WokrahReport:RosterUpdate(...)
end
groupEvents:RegisterEvent("RAID_ROSTER_UPDATE")
groupEvents:RegisterEvent("GROUP_ROSTER_UPDATE")
groupEvents:SetScript("OnEvent", function(self, event, ...) RosterUpdate(...) end)

--[[
    GAME EVENTS
]]
local gameEvents = CreateFrame("Frame")
local function OnLogin(...)
    WokrahComms:OnLogin(...)
    WokrahReport:OnLogin(...)
end
gameEvents:RegisterEvent("PLAYER_LOGIN")
gameEvents:SetScript("OnEvent", function(self, event, ...) OnLogin(...) end)

--[[
    COMM EVENTS
]]
local commsEvents = CreateFrame("Frame")
local function OnCommsReceived(...)
    WokrahComms:OnCommsReceived(...)
end
commsEvents:RegisterEvent("CHAT_MSG_ADDON")
commsEvents:SetScript("OnEvent", function(self, event, ...) OnCommsReceived(...) end)