local events = CreateFrame("Frame")
local SELECTED_PLAYER = nil

function events:UNIT_SPELLCAST_CHANNEL_START(castGUID, spellID)
    if SELECTED_PLAYER ~= nil and spellID == 698 then -- Ritual of Summoning
        -- Once the cast starts we can clear the SELECTED_PLAYER value
        -- This way if we resummon the same player it will announce it again
        SELECTED_PLAYER = nil
    end
end

-- This event gets triggered multiple times, so we validate the playername if we have summoned the same player before
function events:UNIT_SPELLCAST_START(castGUID, spellID)
    if spellID == 698 then -- Ritual of Summoning
        local newSelectedPlayer = GetUnitName("Target")
        if newSelectedPlayer ~= SELECTED_PLAYER then
            local chatType = "PARTY"
            if UnitInRaid("player") then
                chatType = "RAID"
            end

            local zone = GetZoneText()
            local text = "Summoning "..newSelectedPlayer.." to "..zone

            local subZone = GetSubZoneText()
            if subZone and not (subZone == "" or subZone == " ") then
                text = text.." - "..subZone
            end

            SendChatMessage(text, chatType)
            SELECTED_PLAYER = newSelectedPlayer
        end
    end
end

events:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
events:RegisterEvent("UNIT_SPELLCAST_START")
events:SetScript("OnEvent", function(self, event, ...) self[event](...) end)